form(nz-form, [formGroup]="form")
  nz-form-item([nzGutter]="4")
    nz-form-label([nzSpan]="24")
      span
        | {{ workflowModuleInput.displayName }}
        i.ml1(nz-icon, nz-tooltip, [nzTooltipTitle]="helpTemplate", nzType="question-circle", theme="outline")
      ng-template(#helpTemplate)
        span {{ workflowModuleInput.help }}
    nz-form-control([nzSpan]="4")
      nz-select(formControlName="setupMode", [nzCustomTemplate]="optionLabel", [nzDropdownMatchSelectWidth]="false")
        nz-option(nzCustomContent, nzLabel="form", nzValue="static")
          i.mr1(nz-icon, nzType="form")
          | Static value
        nz-option(nzCustomContent, nzLabel="api", nzValue="reference")
          i.mr1(nz-icon, nzType="api")
          | Reference value
      ng-template(#optionLabel, let-selected)
        i(nz-icon, [nzType]="selected.nzLabel")

    nz-form-control([nzSpan]="20")
      ng-container(*ngTemplateOutlet="form.value.setupMode === 'static' ? staticMode : referenceMode")

      // Template for static mode
      ng-template(#staticMode)
        input(*ngIf="hasTextFieldType", nz-input, type="text", formControlName="setupValue", placeholder="Enter input value")
        input(*ngIf="hasPasswordFieldType", nz-input, type="password", formControlName="setupValue", placeholder="Enter input value")
        textarea(*ngIf="hasTextAreaFieldType" rows="4", nz-input, formControlName="setupValue", placeholder="Enter input value")
        input(*ngIf="hasNumberFieldType", nz-input, type="number", formControlName="setupValue", placeholder="Enter input value")
        nz-select(*ngIf="hasSelectFieldType", formControlName="setupValue")
          nz-option(*ngFor="let selectOption of workflowModuleInput.enumValues", [nzValue]="selectOption", [nzLabel]="selectOption")
        ryax-file-input(*ngIf="hasFileFieldType", formControlName="setupValue", (delete)="deleteFile()")
        nz-alert(*ngIf="hasNoFieldType", nzType="info", nzMessage="Input type not handled in static mode", nzShowIcon)

      // Template for reference mode
      ng-template(#referenceMode)
        nz-select(formControlName="setupValue", nzPlaceHolder="Select module output", (nzOpenChange)="onOpenDropdown($event)")
          nz-option-group(*ngFor="let optionGroup of referenceOptions", [nzLabel]="optionGroup.label")
            nz-option(*ngFor="let optionItem of optionGroup.items", [nzLabel]="optionItem.label", [nzValue]="optionItem.value")
